diff --git a/gnu/packages/kde-frameworks.scm b/gnu/packages/kde-frameworks.scm
index 2ae5feaf5..4d4b8ccfc 100644
--- a/gnu/packages/kde-frameworks.scm
+++ b/gnu/packages/kde-frameworks.scm
@@ -23,6 +23,7 @@
 ;;; along with GNU Guix.  If not, see <http://www.gnu.org/licenses/>.
 
 (define-module (gnu packages kde-frameworks)
+  #:use-module (guix build-system gnu)
   #:use-module (guix build-system cmake)
   #:use-module (guix download)
   #:use-module ((guix licenses) #:prefix license:)
@@ -38,6 +39,7 @@
   #:use-module (gnu packages boost)
   #:use-module (gnu packages bison)
   #:use-module (gnu packages boost)
+  #:use-module (gnu packages cdrom)
   #:use-module (gnu packages compression)
   #:use-module (gnu packages databases)
   #:use-module (gnu packages disk)
@@ -3750,3 +3752,80 @@ offers abstract functionality to deal with scripts.")
     ;; under a variety of licenses.
     (license (list license:lgpl2.0+ license:lgpl2.1+
                    license:lgpl2.0 license:gpl3+))))
+
+(define-public acetoneiso
+  (package
+    (name "acetoneiso")
+    (version "2.3")
+    (source (origin
+              (method url-fetch)
+              (uri (string-append
+                    "https://downloads.sourceforge.net/acetoneiso/AcetoneISO/AcetoneISO%20"
+                    version "/acetoneiso_" version ".tar.gz"))
+              (sha256
+               (base32
+                "0s07k8krzjkl2gpq2a7lxngijfxk81h37v5rrs98iw13bll6y7pa"))
+              (patches (search-patches "acetoneiso-no-qtwebkit.patch"))))
+    (build-system gnu-build-system)
+    (inputs
+     ;; TODO: Package fuseiso, cdrdao.
+     `(("cdrtools" ,cdrtools)
+       ("dvd+rw-tools" ,dvd+rw-tools)
+       ;; ("gnupg" ,gnupg)
+       ;; ("pinentry" ,pinentry)
+       ("mplayer" ,mplayer)
+       ("phonon" ,phonon)
+       ;; ("qtwebkit" ,qtwebkit)
+       ("qtbase" ,qtbase)))
+    (arguments
+     `(#:tests? #f                      ;no tests
+       #:phases
+       (modify-phases %standard-phases
+         (add-after 'unpack 'use-qt5
+           ;; See https://git.archlinux.org/svntogit/community.git/tree/trunk/PKGBUILD?h=packages/acetoneiso2.
+           (lambda* (#:key inputs #:allow-other-keys)
+             ;; (substitute* "acetoneiso/sources/acetoneiso.h"
+             ;;   (("#include <QtWebKit>\n") ""))
+             (let ((phonon (assoc-ref inputs "phonon"))
+                   (qt (assoc-ref inputs "qtbase")))
+               (substitute* "acetoneiso/acetoneiso.pro"
+                 ;; Need to specify target or else nothing will be built.
+                 (("TARGET = ") "TARGET = acetoneiso")
+                 ;; Remove webkit.
+                 ;; (("QT \\+= webkit") "")
+                 ;; Use Qt5
+                 (("QT \\+= phonon") "LIBS += -lphonon4qt5")
+                 (("INCLUDEPATH \\+= ." all)
+                  (string-append all
+                                 " " qt "/include/qt5/QtWidgets"
+                                 " " phonon "/include/phonon4qt5"
+                                 " " phonon "/include/phonon4qt5/phonon")))
+               (substitute* (find-files "acetoneiso/sources" ".")
+                 (("QtGui") "QtWidgets")
+                 (("getInteger") "getInt")
+                 (("WFlags") "WindowFlags")))
+             #t))
+         (replace 'configure
+           (lambda _
+             (chdir "acetoneiso")
+             (invoke "qmake")))
+         (replace 'install
+           (lambda* (#:key outputs #:allow-other-keys)
+             (invoke "make" (string-append "INSTALL_ROOT="
+                                           (assoc-ref outputs "out"))
+                     "install"))))))
+    (home-page "https://sourceforge.net/projects/acetoneiso")
+    (synopsis "All in one ISO tool (BIN MDF NRG IMG DAA DMG CDI B5I BWI PDI ISO)")
+    (description "AcetoneISO is a feature-rich and complete software
+application to manage CD/DVD images.  It will let you mount typical images
+formats such as ISO BIN NRG MDF IMG and do plenty of other things:
+
+@itemize
+@item Mount most common Windows images in a clean and easy GUI.
+@item Convert all known images to ISO or extract the contents to a folder.
+@item Encrypt, compress, split any type of image.
+@item Download videos from Youtube.
+@item Convert DVD video to Xvid .avi and any generic video to Xvid .avi.
+@item Extract audio from a video.
+@end itemize\n")
+    (license license:gpl3+)))
diff --git a/gnu/packages/patches/acetoneiso-no-qtwebkit.patch b/gnu/packages/patches/acetoneiso-no-qtwebkit.patch
new file mode 100644
index 000000000..7c6e78aaf
--- /dev/null
+++ b/gnu/packages/patches/acetoneiso-no-qtwebkit.patch
@@ -0,0 +1,99 @@
+diff -ur acetoneiso_2.3.orig/acetoneiso/acetoneiso.pro acetoneiso_2.3/acetoneiso/acetoneiso.pro
+--- acetoneiso_2.3.orig/acetoneiso/acetoneiso.pro	2010-11-11 19:52:33.000000000 +0100
++++ acetoneiso_2.3/acetoneiso/acetoneiso.pro	2017-02-07 09:40:46.751204646 +0100
+@@ -59,7 +59,6 @@
+ QT += phonon
+ QT += dbus
+ #QT += svg
+-QT += webkit
+ 
+ #install#
+     target.path = /usr/bin
+diff -ur acetoneiso_2.3.orig/acetoneiso/sources/acetoneiso.cpp acetoneiso_2.3/acetoneiso/sources/acetoneiso.cpp
+--- acetoneiso_2.3.orig/acetoneiso/sources/acetoneiso.cpp	2010-11-11 21:36:19.000000000 +0100
++++ acetoneiso_2.3/acetoneiso/sources/acetoneiso.cpp	2017-02-07 09:36:27.715760057 +0100
+@@ -16,7 +16,6 @@
+ 
+ #include <QtGui>
+ #include <QTabWidget>
+-#include <QWebView>
+ #include "acetoneiso.h"
+ #include "connections.h"
+ #include <fcntl.h>
+diff -ur acetoneiso_2.3.orig/acetoneiso/sources/acetoneiso.h acetoneiso_2.3/acetoneiso/sources/acetoneiso.h
+--- acetoneiso_2.3.orig/acetoneiso/sources/acetoneiso.h	2010-11-11 00:56:58.000000000 +0100
++++ acetoneiso_2.3/acetoneiso/sources/acetoneiso.h	2017-02-07 09:36:44.429505254 +0100
+@@ -21,8 +21,6 @@
+ #include <QListWidget>
+ #include <QTabWidget>
+ #include <QDebug>
+-#include <QtWebKit>
+-#include <QWebView>
+ #include <QProcess>
+ #include"progress.h"
+ #include"QFileSystemModel"
+diff -ur acetoneiso_2.3.orig/acetoneiso/ui/acetoneiso.ui acetoneiso_2.3/acetoneiso/ui/acetoneiso.ui
+--- acetoneiso_2.3.orig/acetoneiso/ui/acetoneiso.ui	2010-11-15 02:34:50.000000000 +0100
++++ acetoneiso_2.3/acetoneiso/ui/acetoneiso.ui	2017-02-07 09:37:46.144278448 +0100
+@@ -466,47 +466,6 @@
+         </property>
+        </widget>
+       </widget>
+-      <widget class="QWidget" name="tab_2">
+-       <attribute name="icon">
+-        <iconset resource="../acetoneiso.qrc">
+-         <normaloff>:/images/splash.png</normaloff>:/images/splash.png</iconset>
+-       </attribute>
+-       <attribute name="title">
+-        <string>Updates</string>
+-       </attribute>
+-       <layout class="QGridLayout" name="gridLayout_4">
+-        <item row="0" column="0">
+-         <widget class="QWebView" name="webView" native="true">
+-          <property name="sizePolicy">
+-           <sizepolicy hsizetype="Expanding" vsizetype="Expanding">
+-            <horstretch>0</horstretch>
+-            <verstretch>0</verstretch>
+-           </sizepolicy>
+-          </property>
+-          <property name="minimumSize">
+-           <size>
+-            <width>260</width>
+-            <height>100</height>
+-           </size>
+-          </property>
+-          <property name="maximumSize">
+-           <size>
+-            <width>6000</width>
+-            <height>6000</height>
+-           </size>
+-          </property>
+-          <property name="toolTip">
+-           <string>Real time updates from the net</string>
+-          </property>
+-          <property name="url" stdset="0">
+-           <url>
+-            <string>http://www.acetoneteam.org/clients.html</string>
+-           </url>
+-          </property>
+-         </widget>
+-        </item>
+-       </layout>
+-      </widget>
+      </widget>
+     </item>
+     <item row="1" column="0">
+@@ -1810,13 +1769,6 @@
+    </property>
+   </action>
+  </widget>
+- <customwidgets>
+-  <customwidget>
+-   <class>QWebView</class>
+-   <extends>QWidget</extends>
+-   <header>QtWebKit/QWebView</header>
+-  </customwidget>
+- </customwidgets>
+  <tabstops>
+   <tabstop>listWidget_2</tabstop>
+  </tabstops>